//Team: Gian 2c, Shayan 2c, Daniel 2c
//Version: 5
//Soundtrack: Library import
 import processing.sound.*;
 SoundFile soundtrack;

//Grafiti Bilder + allgemeine Bilder
PImage Startbildschirm;
PImage Anweisungen;
PImage GameOver;
PImage Game;
PImage Pfeiltasten;
PImage Maus;
PImage RotesKreuz;

//Zustände verschiedene Ansichten des Spiels
boolean erste_seite = true;
boolean zweite_seite = false;
boolean dritte_seite = false;
boolean color_selection = false;
boolean gameover = false;

//klick-Sperre (Damit processing nicht mehrere Klicks erkennt wenn die Maus lange gedrückt wird)
int klick_timer = 0;

//Definierung von 5 Arrays vom Typ "color" mit Namen "Colors_1" und "Colors_2", die man dann später im Farbenauswahlmenü braucht
color[] Colors_1 = new color[5];
color[] Colors_2 = new color[5];

//Braucht man für die später ausgewählte Farbe//da man noch nichts ausgewählt hat, ist momentan noch Color_1 = 0 & Color_2 = 0
int Color_1 = 0;
int Color_2 = 0;

//Braucht man, um zu erkennen, auf welcher Farbe man im Auswahlmenü ist//die Zahl 0 wird dann mit +1 bzw. -1 etc. erhöht, wenn man auf die linke bzw. rechte Taste drückt mit Aufschrift '<' bzw. '>'
int TempColor1 = 0;
int TempColor2 = 0;

//1. Punkt zum Bewegen//x-Koordinate des Punktes//y-Koordinate des Punktes//Geschwindigkeit des Punktes//Grösse des Punktes//momentane Koordinaten (bzgl. schwarzer Farben Kollision
int x1 = 70;
int y1 = 700;
int speed1 = 5;
int pointSize1 = 20;
int prevX1,prevY1;

//2. Punkt zum Bewegen//x-Koordinate des Punktes//y-Koordinate des Punktes//Geschwindigkeit des Punktes//Grösse des Punktes//momentane Koordinaten (bzgl. schwarzr Farben Kollision
int x2 = 1100;
int y2 = 100;
int speed2 = 6;
int pointSize2 = 20;
int prevX2,prevY2;

//Timer//in Sekunden//Letzte Aktualisierungszeit des Timers
int timer = 30;
int lastTime = 0; 

//---------------------------------------------------------------------------------------------------------------------------------------------
void setup(){
  //Screensize auf 1200x800 Pixel
  size(1200, 800);
  
  //Bilder laden unter dem Ordner Images
  Startbildschirm = loadImage( "Images/Startbildschirm.jpg" );
  Anweisungen = loadImage("Images/Anweisungen.jpg");
  GameOver = loadImage("Images/Gameover.jpg");
  Game = loadImage("Images/Game.jpg");
  Pfeiltasten = loadImage("Images/Pfeiltasten.png");
  Maus = loadImage("Images/Maus.png");
  RotesKreuz = loadImage("Images/RotesKreuz.png");
  
  //Arrays für die diversen Farben//erste Zahl von color(); keine Null, sonst erkennt dies das Programm als schwarze Farbe
  Colors_1[0] = color(204, 0, 0);
  Colors_1[1] = color(255, 153, 51);
  Colors_1[2] = color(255, 255, 0);
  Colors_1[3] = color(40, 204, 0); 
  Colors_1[4] = color(51, 102, 0);
  
  Colors_2[0] = color(40, 76, 153); 
  Colors_2[1] = color(40, 204, 204); 
  Colors_2[2] = color(153, 0, 153);
  Colors_2[3] = color(255, 153, 204);
  Colors_2[4] = color(153, 204, 255);
  
 //Soundtrack im Ordner Images + Soundtrack im Loop abspielen
 soundtrack = new SoundFile(this,"Images/Soundtrack.wav");
    soundtrack.play();
    soundtrack.loop();
  
}
//---------------------------------------------------------------------------------------------------------------------------------------------
void draw(){
  
   //Management verschiedene Ansichten des Spiels
  if(color_selection == true){
    ColorSelection();
  }
  if(erste_seite == true){
    startbildschirm();
  }
  if(zweite_seite == true){
    anweisungen();
  }
  if(dritte_seite == true){
    game();
  }
  if(gameover == true) {
    gameover();
  }
  
  //Zurücksetzten von Klick-delay
  if(klick_timer > 0){
    klick_timer--;
  }
}

//---------------------------------------------------------------------------------------------------------------------------------------------
void startbildschirm(){
  
  //Hintergrundbild des Startbildschirms
  image(Startbildschirm, 0, 0, 1200, 800);
  
  //Knopf //Knopftext mit Anweisungen
  rectMode(CENTER);
  stroke(255);
  strokeWeight(6);
  noFill();
  rect(1000, 700, 300, 100, 5);
  textSize(45);
  textAlign(CENTER, CENTER);
  text("Anweisungen", 1000, 690);
  
  //Knopfdruck erkennen und auf nächste Seite switchen
  if(mousePressed){
    if(mouseX > 850 && mouseX < 1150 && mouseY > 650 && mouseY < 750 && klick_timer == 0){
      erste_seite = false;
      zweite_seite = true;
      
      //Klick-delay
      klick_timer = 15;
    }
  }
}

//---------------------------------------------------------------------------------------------------------------------------------------------
void anweisungen(){
  
  //Hintergrundbild der Anweisungen
  image(Anweisungen, 0, 0, 1200, 800);
  
  //Text zur Spielanweisung + Bilder Maus & Tastatur: Pfeiltasten
  textSize(25);
  textAlign(LEFT);
  //Einleitung//pro Zeile immer +30 y Wert
  text("Ein Fangspiel in einem Labyrinth, wo es einen Fänger und einen Läufer gibt. Der Läufer muss eine" ,40,200);
  text("bestimmte Zeit vor dem Fänger davonrennen. " ,40, 230);
  //Spielverläufe//Abstand von der Einleitung +50//pro Zeile immer +30 y Wert
  text("Somit gibt es 2 mögliche Spielverläufe:" ,40,270);
  text("1. Falls der Fänger den Läufer fängt, gewinnt der Fänger." ,40,300);
  text("2. Falls die bestimmte Zeit um ist, gewinnt der Läufer." ,40,330);
  //Schlusteil//Abstand von den Spielverläufen + 50//pro Zeile immer +30 y Wert
  text("Die Rollen werden anschliessend getauscht. Es gibt auch einen Teleportationspunkt. Wenn man" ,40,380);
  text("diesen berührt, wird man auf den eigenen Spawnpunkt zurückteleportiert." ,40,410);
  text("Spielbedienungen:", 60, 450);
   //Image Pfeiltasten//2400x1562 Pixel gross//:an 12
   image(Pfeiltasten,320,470,200,130.6);
   //Image Maus//800x800 Pixel gross//: an 6
   image(Maus,540,470,133.3,133.3);
  text("Fänger = Maus", 700,460);
  text("Läufer = Pfeiltasten",700,490);
  
  //Farbenauswahlmenüknopf//Knopftext mit 'press x'
  rectMode(CENTER);
  stroke(0);
  strokeWeight(6);
  noFill();
  rect(180,700, 300, 100, 5);
  textSize(45);
  textAlign(CENTER, CENTER);
  text("press 'x'", 150, 690);
  textSize(30);
  text("Farbenauswahl:",120,610);
  
  //if Funktion für Öffnen des Farbenauswahlmenü
    if (keyPressed && key == 'x') {
      color_selection = true;
      zweite_seite = false;
       klick_timer = 15;
}
  
  //Knopf//Knopftext mit Spielen
  rectMode(CENTER);
  stroke(0);
  strokeWeight(6);
  noFill();
  rect(1000, 700, 300, 100, 5);
  fill(0);
  textSize(50);
  textAlign(CENTER, CENTER);
  text("Spielen", 1000, 690);
  textSize(30);
  text("Anklicken zum Game:",990,610);
  
  //Knopfdruck erkennen und auf nächste Seite switchen
  if(mousePressed){
    if(mouseX > 850 && mouseX < 1150 && mouseY > 650 && mouseY < 750 && klick_timer == 0){
      zweite_seite = false;
      dritte_seite = true;
      
      //Klick-delay
      klick_timer = 15;
    }
  }
}

//---------------------------------------------------------------------------------------------------------------------------------------------
void ColorSelection(){
  
  //Hintergrundbild der Anweisungen einfach vegrössert bzw. verzerrt, damit man nicht mehr das Grafiti sieht, sondern nur die Hintergundfarbe
  image(Anweisungen,0,0,6000,20000);
  
  //weisse Rechtecke, in denen die Farben etc. sind
  rectMode(CENTER);
  noStroke();
  fill(255);
  rect(300, 300, 500, 300, 20);
  rect(900, 300, 500, 300, 20);
 
  //Rechtecke mit Aufschrift Fänger und Läufer + Farbe der Spawnpunkte
  fill(#6B87D8);
  rect(300, 90, 500, 80, 20);
  fill(#6B87D8);
  rect(900, 90, 500, 80, 20);
  textAlign(CENTER, CENTER);
  textSize(60);
  fill(0);
  text("Fänger", 900, 80);
  text("Läufer", 300, 80);
  
  //Knöpfe auf der linken Seite
  stroke(0);
  strokeWeight(6);
  noFill();
  rect(300, 510, 320, 80, 20);
  rect(90, 510, 80, 80, 20);
  rect(510, 510, 80, 80, 20);
  fill(0);
  textSize(60);
  text("<", 90, 505);
  text(">", 510, 505);
  fill(0);
  textSize(40);
  text("Auswählen", 300, 505);
  
  //Knöpfe auf der rechten Seite
  stroke(0);
  strokeWeight(6);
  noFill();
  rect(900, 510, 320, 80, 20);
  rect(690, 510, 80, 80, 20);
  rect(1110, 510, 80, 80, 20);
  fill(0);
  textSize(60);
  text("<", 690, 505);
  text(">", 1110, 505);
  fill(0);
  textSize(40);
  text("Auswählen", 900, 505);
  
  //Rechteck mit Aufschrift zurück zur Spielanleitung
  stroke(0);
  strokeWeight(6);
  noFill();
  rect(600, 700, 500, 100, 20);
  fill(0);
  textSize(30);
  text("Zurück zur Spielanleitung", 600, 700);
  
  //Punkte die angezeigt werden, werden mit der entsprechenden Farbe aus dem Array gefüllt, wenn man auf '>' bzw '<' drückt
  fill(Colors_1[TempColor1]);
  circle(300, 300, 200);
  
  fill(Colors_2[TempColor2]);
  circle(900, 300, 200);
  
  if(mousePressed){
    //Erkennen, ob der linke Knopf der Auswahl vom Runner gedrückt wurde, um die Farbe von Color_1 zu verringern//mit Println: ok kann man in der Konsole sehen, ob der Knopfdruck bestätigt bzw. ausgeführt wurde oder nicht
     if(mouseX > 50 && mouseX < 130 && mouseY > 470 && mouseY < 550 && klick_timer == 0){
        println("ok");
        klick_timer = 15;
        if(TempColor1>0){
          TempColor1--;
        }
      }
     //Erkennen, ob der rechte Knopf der Auswahl vom Runner gedrückt wurde, um die Farbe von Color_1 zu erhöhen
     if(mouseX > 470 && mouseX < 550 && mouseY > 470 && mouseY < 550 && klick_timer == 0){
        print("ok");
        klick_timer = 15;
        if(TempColor1 < 4){
          TempColor1++;
        }
      }
     //Erkennen, ob der mittlere Knopf der Auswahl vom Runner gedrückt wurde, um die endgültige Farbe von Color_1 festzulegen
     if(mouseX > 140 && mouseX < 460 && mouseY > 470 && mouseY < 550 && klick_timer == 0){
        print("ok");
        klick_timer = 15;
        
        Color_1 = TempColor1; 
      }
      
    //Erkennen, ob der linke Knopf der Auswahl vom Catcher gedrückt wurde, um die Farbe von Color_2 zu verringern
     if(mouseX > 650 && mouseX < 730 && mouseY > 470 && mouseY < 550 && klick_timer == 0){
        println("ok");
        klick_timer = 15;
        if(TempColor2>0){
          TempColor2--;
        } 
      }
     //Erkennen, ob der rechte Knopf der Auswahl vom Catcher gedrückt wurde, um die Farbe von Color_2 zu erhöhen
     if(mouseX > 1070 && mouseX < 1150 && mouseY > 470 && mouseY < 550 && klick_timer == 0){
        print("ok");
        klick_timer = 15;
        if(TempColor2 < 4){
          TempColor2++;
        }
      }
     //Erkennen, ob der mittlere Knopf der Auswahl vom Catcher gedrückt wurde, um die endgültige Farbe von Color_2 festzulegen
     if(mouseX > 740 && mouseX < 1060 && mouseY > 470 && mouseY < 550 && klick_timer == 0){
        print("ok");
        klick_timer = 15;
        
        Color_2 = TempColor2;
      }
      
     //Zur Anleitung zurück per Mausklick, somit zurück zur 2. Seite switchen
     if(mouseX > 350 && mouseX < 850 && mouseY > 650 && mouseY < 750 && klick_timer == 0){
        print("ok");
        klick_timer = 15;
        
        zweite_seite = true;
        color_selection = false;
    }
  }
}

//---------------------------------------------------------------------------------------------------------------------------------------------
void game() {
  
 //Hintergundbild des Games
 image(Game,0,0,1210,850);
  
  //1. Spawnpunkt//mit gleicher Farbe wie die Rechtecke mit der Aufschrift Runner bzw. Catcher im Auswahlmenü
  fill(#6B87D8);
  ellipse(68,713,92,92);
  //2.Spawnpunkt//analog zum 1. Spawnpunkt
  fill(#6B87D8);
  ellipse(1135,135,92,92);
  
  //Alle Rechtecke//1-36//Rechtecke als Wände bzw. Genzen für die Punkte des Labyrinths mit schwarzer Farbe
  fill(0);
  rectMode(CORNER);
  noStroke();
  //1-36
  rect(0,0,95,655);
  rect(0,655,18,148);
  rect(18,765,162,35);
  rect(175,695,520,106);
  rect(695,755,505,45);
  rect(1105,195,95,560);
  rect(1028,195,77,30);
  rect(1185,70,15,125);
  rect(95,0,1105,70);
  rect(272,70,90,70);
  rect(145,428,218,137);
  rect(177,592,243,64);
  rect(145,288,90,140);
  rect(182,104,44,72);
  rect(141,176,289,78);
  rect(275,228,213,139);
  rect(461,549,43,147);
  rect(902,563,148,139);
  rect(939,328,74,109);
  rect(1013,377,92,60);
  rect(836,222,121,50);
  rect(607,273,123,93);
  rect(461,127,189,71);
  rect(520,198,45,96);
  rect(650,127,67,120);
  rect(717,107,81,140);
  rect(798,107,130,82);
  rect(774,247,24,90);
  rect(868,331,37,138);
  rect(823,469,158,62);
  rect(823,531,43,190);
  rect(750,653,73,68);
  rect(538,557,285,50);
  rect(729,469,51,88);
  rect(408,477,250,46);
  rect(430,411,97,66);
 
 //Farben mit Fänger und Läufer, die im Auswahlmenü ausgewählt worden sind
 fill(Colors_1[Color_1]);
 text("RUNNER",200,25);
 fill(Colors_2[Color_2]);
 text("CATCHER",1000,25);
 
 //Teleportationspunkt zeichnen + zurückteleportieren, wenn man auf ihn kommt
 fill(#FFB20A);
 ellipse(650,410,90,50);
 
 if(dist(x1,y1,650,410) < 30) {
    x1 = 70;
    y1 = 700;
 }
 if(dist(x2,y2,650,400) < 30) {
    x2 = 1100;
    y2 = 100;
 }
   
 //1. Punkt zeichen mit Farbe, die im Auswahlmenü ausgewählt worden ist//aktuelle x1 und y1 Koordinaten
  fill(Colors_1[Color_1]);
  ellipse(x1,y1,pointSize1, pointSize1);
  prevX1 = x1;
  prevY1 = y1;

  //2. Punkt zeichnen mit Farbe, die im Auswahlmenü ausgewählt worden ist//aktuelle x2 und y2 Koordinaten
  fill(Colors_2[Color_2]);
  ellipse(x2,y2,pointSize2,pointSize2);
  prevX2 = x2;
  prevY2 = y2;

//1. Punkt Bewegung anhand von Pfeiltasten
  if (keyPressed &&(keyCode == UP || keyCode == DOWN || keyCode == LEFT || keyCode == RIGHT)) { 
   if (keyCode == UP) {
   y1 = max(y1 - speed1, pointSize1); //obere Grenze
  } else if (keyCode == DOWN) {
   y1 = min(y1 + speed1, height - pointSize1); //untere GRenze
  } else if (keyCode == LEFT) {
   x1 = max(x1 - speed1, pointSize1); //linke Grenze
  } else if (keyCode == RIGHT) {
   x1 = min(x1 + speed1, width - pointSize1); // rechte Grenze
   }
}

//2. Punkt Bewegung anhand der Maus
  // Überprüft, ob die Maus innerhalb des Fensters ist, nur dann kann man mit der Maus den 2. Punkt bewegen
  if (mouseX > 0 && mouseX < width && mouseY > 0 && mouseY < height) {
    // Berechnet die Entfernung zwischen dem 2. Punkt und der Maus in horizontaler und vertikaler Richtung
    float dx2 = mouseX - x2;
    float dy2 = mouseY - y2;
    
    // Bewegt den Punkt horizontal
    if (abs(dx2) > speed2) {
      x2 += dx2 > 0 ? speed2 : -speed2; // Wenn dx positiv ist, bewege den Punkt nach rechts, sonst bewege ihn nach links
    } else {
      x2 = mouseX; // Wenn die Entfernung kleiner als die Geschwindigkeit ist, setze den Punkt auf die Mausposition
    }
    
    // Bewegt den Punkt vertikal
    if (abs(dy2) > speed2) {
      y2 += dy2 > 0 ? speed2 : -speed2; // Wenn dy positiv ist, bewege den Punkt nach unten, sonst bewege ihn nach oben
    } else {
      y2 = mouseY; // Wenn die Entfernung kleiner als die Geschwindigkeit des 2. Punktes ist, setze den Punkt auf die Mausposition
    }
   //Überprüfen, ob die Farbe des Pixels rechts und links von der aktuellen Position von x2 und y2 dunkler als die Farbe 40 ist
   if(get((int) x2+pointSize2/2-1, (int)y2) <= color(40) || get((int) x2-pointSize2/2, (int)y2) <= color(40)) {
        //Wenn ja, dann wird x2 und y2 auf ihre vorherigen Werte zurückgesetzt, um zu verhindern, dass der 2. Punkt in die dunklen Bereiche bzw. in die Wand fährt
        x2 = prevX2;
        y2 = prevY2;
   } else {
       //Wenn nein, dann wird die vorherigen Positionen von x2 und y2 auf ihre aktuellen Positionen zurückgesetzt, um sich auf die nächste Bewegung vorzubereiten
       prevX2 = x2;
       prevY2 = y2;
     } 
}
 
//Überprüfen, ob die Farbe des Pixels rechts und links von der aktuellen Position von x1 und y1 dunkler als die Farbe 35 ist 
if(get((int) x1+pointSize1/2-1, (int)y1) <= color(35) || get((int) x1-pointSize1/2, (int)y1) <= color(35)) {
  //Wenn ja, dann wird x1 und y1 auf ihre vorherigen Werte zurückgesetzt, um zu verhindern, dass der 1. Punkt in die dunklen Bereiche bzw. in die Wand fährt
  x1 = prevX1;
  y1 = prevY1;
}else{
  //Wenn nein, dann wird die vorherigen Positionen von x1 und y1 auf ihre aktuellen Positionen zurückgesetzt, um sich auf die nächste Bewegung vorzubereiten
  prevX1 = x1;
  prevY1 = y1;
}

//1. Gameover durch Timer
if(dritte_seite == true) {
  if(millis() - lastTime >= 1000) { //Überprüfen, ob die Zeit seit dem letzten Mal, als der Timer aktualisiert wurde, mindestens 1 Sekunde beträgt
   timer--;//Der Timer wird um 1 verringert und die letzte Zeit auf die aktuelle Zeit gesetzt
   lastTime = millis();
  }
  if(timer >=0) {  //Wenn der Timer größer oder gleich 0 ist, dann wird der Timer in Sekunden gezeichnet
   fill(255);
   textSize(40);
   text("TIMER:" + timer, 600,25);
   }else{ //Wenn der Timer abgelaufen ist, dann wird auf Gameover geswitcht
   gameover = true;
  }
}

//2. Gameover wenn beide Punkte auf den selben Koordinaten sind
if(dist(x1,y1,x2,y2) <10){
 gameover = true;
 }
}

//---------------------------------------------------------------------------------------------------------------------------------------------
void gameover() {
 
  //Hintergundbild des Gameover
  image(GameOver,0,0,1200,800);

 //Wer hat gewonnen?
 if(timer >=0) { //Wenn Timer >= 0 ist, dann hat der Fänger gewonnen//Text CATCHER won
   textSize(50);
   fill(Colors_2[Color_2]);
   text("CATCHER", 400,600);
   fill(255);
   text("won", 550,600);
   timer = 30;
 }else{ //Wenn Timer abgelaufen ist, dann hat der Läufer gewonnen//Text RUNNER won
   textSize(50);
   fill(Colors_1[Color_1]);
   text("RUNNER", 400,600);
   fill(255);
   text("won", 550,600);
 }
 
  //Knopf//Knopftext mit RESTART
  rectMode(CENTER);
  stroke(255);
  strokeWeight(6);
  noFill();
  rect(1000, 700, 300, 100, 5);
  textSize(45);
  textAlign(CENTER, CENTER);
  fill(255);
  text("RESTART", 1000, 690);
  
  //Knopfdruck erkennen, um auf Game zu switchen
  if(mousePressed){
    if(mouseX > 850 && mouseX < 1150 && mouseY > 650 && mouseY < 750 && klick_timer == 0){
      gameover = false;
      dritte_seite = true;
      
      //Variablen zurücksetzten, um auf der dritten Seite wieder von Anfang an zu spielen
       x1 = 70;
       y1 = 700;
       speed1 = 5;
       pointSize1 = 20;
       
       x2 = 1100;
       y2 = 100;
       speed2 = 5;
       pointSize2 = 20;
       
       timer = 30;
       lastTime = 0;
      
      //Klick-delay
      klick_timer = 15;
    }
  }
}
